JUCE: Range< ValueType > Class Template Reference

JUCE

Public Member Functions | Static Public Member Functions | List of all members
Range< ValueType > Class Template Reference

A general-purpose range object, that simply represents any linear range with a start and end point. More...

## Public Member Functions
JUCE_CONSTEXPR | Range ()=default
| Constructs an empty range. More...
JUCE_CONSTEXPR | Range (const ValueType startValue, const ValueType endValue) noexcept
| Constructs a range with given start and end values. More...
JUCE_CONSTEXPR | Range (const Range &)=default
| Constructs a copy of another range. More...
Range & | operator= (const Range &)=default
| Copies another range object. More...
JUCE_CONSTEXPR ValueType | getStart () const noexcept
| Returns the start of the range. More...
JUCE_CONSTEXPR ValueType | getLength () const noexcept
| Returns the length of the range. More...
JUCE_CONSTEXPR ValueType | getEnd () const noexcept
| Returns the end of the range. More...
JUCE_CONSTEXPR bool | isEmpty () const noexcept
| Returns true if the range has a length of zero. More...
void | setStart (const ValueType newStart) noexcept
| Changes the start position of the range, leaving the end position unchanged. More...
JUCE_CONSTEXPR Range | withStart (const ValueType newStart) const noexcept
| Returns a range with the same end as this one, but a different start. More...
JUCE_CONSTEXPR Range | movedToStartAt (const ValueType newStart) const noexcept
| Returns a range with the same length as this one, but moved to have the given start position. More...
void | setEnd (const ValueType newEnd) noexcept
| Changes the end position of the range, leaving the start unchanged. More...
JUCE_CONSTEXPR Range | withEnd (const ValueType newEnd) const noexcept
| Returns a range with the same start position as this one, but a different end. More...
JUCE_CONSTEXPR Range | movedToEndAt (const ValueType newEnd) const noexcept
| Returns a range with the same length as this one, but moved to have the given end position. More...
void | setLength (const ValueType newLength) noexcept
| Changes the length of the range. More...
JUCE_CONSTEXPR Range | withLength (const ValueType newLength) const noexcept
| Returns a range with the same start as this one, but a different length. More...
JUCE_CONSTEXPR Range | expanded (ValueType amount) const noexcept
| Returns a range which has its start moved down and its end moved up by the given amount. More...
Range | operator+= (const ValueType amountToAdd) noexcept
| Adds an amount to the start and end of the range. More...
Range | operator-= (const ValueType amountToSubtract) noexcept
| Subtracts an amount from the start and end of the range. More...
JUCE_CONSTEXPR Range | operator+ (const ValueType amountToAdd) const noexcept
| Returns a range that is equal to this one with an amount added to its start and end. More...
JUCE_CONSTEXPR Range | operator- (const ValueType amountToSubtract) const noexcept
| Returns a range that is equal to this one with the specified amount subtracted from its start and end. More...
JUCE_CONSTEXPR bool | operator== (Range other) const noexcept
JUCE_CONSTEXPR bool | operator!= (Range other) const noexcept
JUCE_CONSTEXPR bool | contains (const ValueType position) const noexcept
| Returns true if the given position lies inside this range. More...
ValueType | clipValue (const ValueType value) const noexcept
| Returns the nearest value to the one supplied, which lies within the range. More...
JUCE_CONSTEXPR bool | contains (Range other) const noexcept
| Returns true if the given range lies entirely inside this range. More...
JUCE_CONSTEXPR bool | intersects (Range other) const noexcept
| Returns true if the given range intersects this one. More...
JUCE_CONSTEXPR Range | getIntersectionWith (Range other) const noexcept
| Returns the range that is the intersection of the two ranges, or an empty range with an undefined start position if they don't overlap. More...
JUCE_CONSTEXPR Range | getUnionWith (Range other) const noexcept
| Returns the smallest range that contains both this one and the other one. More...
JUCE_CONSTEXPR Range | getUnionWith (const ValueType valueToInclude) const noexcept
| Returns the smallest range that contains both this one and the given value. More...
Range | constrainRange (Range rangeToConstrain) const noexcept
| Returns a given range, after moving it forwards or backwards to fit it within this range. More...

## Static Public Member Functions
static JUCE_CONSTEXPR Range | between (const ValueType position1, const ValueType position2) noexcept
| Returns the range that lies between two positions (in either order). More...
static Range | withStartAndLength (const ValueType startValue, const ValueType length) noexcept
| Returns a range with a given start and length. More...
static JUCE_CONSTEXPR Range | emptyRange (const ValueType start) noexcept
| Returns a range with the specified start position and a length of zero. More...
static Range | findMinAndMax (const ValueType *values, int numValues) noexcept
| Scans an array of values for its min and max, and returns these as a Range. More...

## Detailed Description

### template<typename ValueType>
class Range< ValueType >

A general-purpose range object, that simply represents any linear range with a start and end point.

Note that when checking whether values fall within the range, the start value is considered to be inclusive, and the end of the range exclusive.

The templated parameter is expected to be a primitive integer or floating point type, though class types could also be used if they behave in a number-like way.

## Constructor & Destructor Documentation

## ◆ Range() [1/3]

template<typename ValueType >

JUCE_CONSTEXPR Range< ValueType >::Range | ( |  | ) |
| default

Constructs an empty range.

Referenced by Range< int64 >::between(), Range< int64 >::emptyRange(), Range< int64 >::expanded(), Range< int64 >::getIntersectionWith(), Range< int64 >::getUnionWith(), Range< int64 >::movedToEndAt(), Range< int64 >::movedToStartAt(), Range< int64 >::operator+(), Range< int64 >::operator-(), Range< int64 >::withEnd(), Range< int64 >::withLength(), Range< int64 >::withStart(), and Range< int64 >::withStartAndLength().

## ◆ Range() [2/3]

template<typename ValueType >

JUCE_CONSTEXPR Range< ValueType >::Range | ( | const ValueType | startValue,
|  | const ValueType | endValue
| ) |  |
| noexcept

Constructs a range with given start and end values.

## ◆ Range() [3/3]

template<typename ValueType >

JUCE_CONSTEXPR Range< ValueType >::Range | ( | const Range< ValueType > & |  | ) |
| default

Constructs a copy of another range.

## Member Function Documentation

## ◆ operator=()

template<typename ValueType >

Range& Range< ValueType >::operator= | ( | const Range< ValueType > & |  | ) |
| default

Copies another range object.

## ◆ between()

template<typename ValueType >

static JUCE_CONSTEXPR Range Range< ValueType >::between | ( | const ValueType | position1,
|  | const ValueType | position2
| ) |  |
| staticnoexcept

Returns the range that lies between two positions (in either order).

## ◆ withStartAndLength()

template<typename ValueType >

static Range Range< ValueType >::withStartAndLength | ( | const ValueType | startValue,
|  | const ValueType | length
| ) |  |
| staticnoexcept

Returns a range with a given start and length.

Referenced by Rectangle< int >::getHorizontalRange(), and Rectangle< int >::getVerticalRange().

## ◆ emptyRange()

template<typename ValueType >

static JUCE_CONSTEXPR Range Range< ValueType >::emptyRange | ( | const ValueType | start | ) |
| staticnoexcept

Returns a range with the specified start position and a length of zero.

## ◆ getStart()

template<typename ValueType >

JUCE_CONSTEXPR ValueType Range< ValueType >::getStart | ( |  | ) | const
| noexcept

Returns the start of the range.

Referenced by AudioData::Pointer< SampleFormat, Endianness, InterleavingType, Constness >::findMinAndMax(), SparseSet< int >::getTotalRange(), and SparseSet< int >::removeRange().

## ◆ getLength()

template<typename ValueType >

JUCE_CONSTEXPR ValueType Range< ValueType >::getLength | ( |  | ) | const
| noexcept

Returns the length of the range.

Referenced by Range< int64 >::constrainRange().

## ◆ getEnd()

template<typename ValueType >

JUCE_CONSTEXPR ValueType Range< ValueType >::getEnd | ( |  | ) | const
| noexcept

Returns the end of the range.

Referenced by AudioData::Pointer< SampleFormat, Endianness, InterleavingType, Constness >::findMinAndMax(), SparseSet< int >::getTotalRange(), and SparseSet< int >::removeRange().

## ◆ isEmpty()

template<typename ValueType >

JUCE_CONSTEXPR bool Range< ValueType >::isEmpty | ( |  | ) | const
| noexcept

Returns true if the range has a length of zero.

Referenced by SparseSet< int >::addRange(), and SparseSet< int >::removeRange().

## ◆ setStart()

template<typename ValueType >

void Range< ValueType >::setStart | ( | const ValueType | newStart | ) |
| noexcept

Changes the start position of the range, leaving the end position unchanged.

If the new start position is higher than the current end of the range, the end point will be pushed along to equal it, leaving an empty range at the new position.

## ◆ withStart()

template<typename ValueType >

JUCE_CONSTEXPR Range Range< ValueType >::withStart | ( | const ValueType | newStart | ) | const
| noexcept

Returns a range with the same end as this one, but a different start.

If the new start position is higher than the current end of the range, the end point will be pushed along to equal it, returning an empty range at the new position.

## ◆ movedToStartAt()

template<typename ValueType >

JUCE_CONSTEXPR Range Range< ValueType >::movedToStartAt | ( | const ValueType | newStart | ) | const
| noexcept

Returns a range with the same length as this one, but moved to have the given start position.

## ◆ setEnd()

template<typename ValueType >

void Range< ValueType >::setEnd | ( | const ValueType | newEnd | ) |
| noexcept

Changes the end position of the range, leaving the start unchanged.

If the new end position is below the current start of the range, the start point will be pushed back to equal the new end point.

## ◆ withEnd()

template<typename ValueType >

JUCE_CONSTEXPR Range Range< ValueType >::withEnd | ( | const ValueType | newEnd | ) | const
| noexcept

Returns a range with the same start position as this one, but a different end.

If the new end position is below the current start of the range, the start point will be pushed back to equal the new end point.

## ◆ movedToEndAt()

template<typename ValueType >

JUCE_CONSTEXPR Range Range< ValueType >::movedToEndAt | ( | const ValueType | newEnd | ) | const
| noexcept

Returns a range with the same length as this one, but moved to have the given end position.

## ◆ setLength()

template<typename ValueType >

void Range< ValueType >::setLength | ( | const ValueType | newLength | ) |
| noexcept

Changes the length of the range.

Lengths less than zero are treated as zero.

## ◆ withLength()

template<typename ValueType >

JUCE_CONSTEXPR Range Range< ValueType >::withLength | ( | const ValueType | newLength | ) | const
| noexcept

Returns a range with the same start as this one, but a different length.

Lengths less than zero are treated as zero.

## ◆ expanded()

template<typename ValueType >

JUCE_CONSTEXPR Range Range< ValueType >::expanded | ( | ValueType | amount | ) | const
| noexcept

Returns a range which has its start moved down and its end moved up by the given amount.

Returns
  The returned range will be (start - amount, end + amount)

## ◆ operator+=()

template<typename ValueType >

Range Range< ValueType >::operator+= | ( | const ValueType | amountToAdd | ) |
| noexcept

Adds an amount to the start and end of the range.

## ◆ operator-=()

template<typename ValueType >

Range Range< ValueType >::operator-= | ( | const ValueType | amountToSubtract | ) |
| noexcept

Subtracts an amount from the start and end of the range.

## ◆ operator+()

template<typename ValueType >

JUCE_CONSTEXPR Range Range< ValueType >::operator+ | ( | const ValueType | amountToAdd | ) | const
| noexcept

Returns a range that is equal to this one with an amount added to its start and end.

## ◆ operator-()

template<typename ValueType >

JUCE_CONSTEXPR Range Range< ValueType >::operator- | ( | const ValueType | amountToSubtract | ) | const
| noexcept

Returns a range that is equal to this one with the specified amount subtracted from its start and end.

## ◆ operator==()

template<typename ValueType >

JUCE_CONSTEXPR bool Range< ValueType >::operator== | ( | Range< ValueType > | other | ) | const
| noexcept

## ◆ operator!=()

template<typename ValueType >

JUCE_CONSTEXPR bool Range< ValueType >::operator!= | ( | Range< ValueType > | other | ) | const
| noexcept

## ◆ contains() [1/2]

template<typename ValueType >

JUCE_CONSTEXPR bool Range< ValueType >::contains | ( | const ValueType | position | ) | const
| noexcept

Returns true if the given position lies inside this range.

When making this comparison, the start value is considered to be inclusive, and the end of the range exclusive.

Referenced by SparseSet< int >::removeRange().

## ◆ clipValue()

template<typename ValueType >

ValueType Range< ValueType >::clipValue | ( | const ValueType | value | ) | const
| noexcept

Returns the nearest value to the one supplied, which lies within the range.

## ◆ contains() [2/2]

template<typename ValueType >

JUCE_CONSTEXPR bool Range< ValueType >::contains | ( | Range< ValueType > | other | ) | const
| noexcept

Returns true if the given range lies entirely inside this range.

## ◆ intersects()

template<typename ValueType >

JUCE_CONSTEXPR bool Range< ValueType >::intersects | ( | Range< ValueType > | other | ) | const
| noexcept

Returns true if the given range intersects this one.

## ◆ getIntersectionWith()

template<typename ValueType >

JUCE_CONSTEXPR Range Range< ValueType >::getIntersectionWith | ( | Range< ValueType > | other | ) | const
| noexcept

Returns the range that is the intersection of the two ranges, or an empty range with an undefined start position if they don't overlap.

## ◆ getUnionWith() [1/2]

template<typename ValueType >

JUCE_CONSTEXPR Range Range< ValueType >::getUnionWith | ( | Range< ValueType > | other | ) | const
| noexcept

Returns the smallest range that contains both this one and the other one.

## ◆ getUnionWith() [2/2]

template<typename ValueType >

JUCE_CONSTEXPR Range Range< ValueType >::getUnionWith | ( | const ValueType | valueToInclude | ) | const
| noexcept

Returns the smallest range that contains both this one and the given value.

## ◆ constrainRange()

template<typename ValueType >

Range Range< ValueType >::constrainRange | ( | Range< ValueType > | rangeToConstrain | ) | const
| noexcept

Returns a given range, after moving it forwards or backwards to fit it within this range.

If the supplied range has a greater length than this one, the return value will be this range.

Otherwise, if the supplied range is smaller than this one, the return value will be the new range, shifted forwards or backwards so that it doesn't extend beyond this one, but keeping its original length.

## ◆ findMinAndMax()

template<typename ValueType >

static Range Range< ValueType >::findMinAndMax | ( | const ValueType * | values,
|  | int | numValues
| ) |  |
| staticnoexcept

Scans an array of values for its min and max, and returns these as a Range.

The documentation for this class was generated from the following file:

- juce_Range.h